<!--#include virtual="/.narodsys/metrika_counter.html"-->
<i style="background:url(//www.tns-counter.ru/V13a****yandex_ru/ru/CP1251/tmsec=narod_total/0)"></i>
<!--#include virtual="/.narodsys/direct.html"-->
/*****************************************************************************
**
** program_ugnx4_set_attribute_RIVET_for_rivets.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif












//    
//1.   - 
//2.   RIVET  
//



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>
#include <uf_csys.h>
#include <uf_modl.h>
#include <uf_defs.h>
#include <uf_mtx.h>


static	FILE*	prterr;
static	int		errorCode;

static	tag_t	parent_part;
static	tag_t	base_CSYS;




//   
#define	PRTERR if(errorCode){PrintErrorMessage(errorCode,__LINE__);goto term;}





//   
static	void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"\n	errorCode=%d	message=%s	line=%d\n",
			errorCode,message,line);
		fflush(prterr);
		errorCode=0;
	}
}






//   
int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}







// 
int	do_it(void)
{

	tag_t*	component_group;
	int		component_count;

	

	//  - 
get_components:
	{
		char*	message="   - ";
		char*	title=" - ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_p_t	object;
		int		count;
		int		i;

		errorCode=UF_UI_select_with_class_dialog
		(message,title,scope,component_init_proc,NULL,&response,&count,&object);
		PRTERR;

		switch(response)
		{

		case UF_UI_BACK:
			goto get_components;

		case UF_UI_CANCEL:
			goto term;

		case UF_UI_OK:
			break;
		}

		//   ?
		if(count==0)
		{
			uc1601("     - ",1);
			goto get_components;
		}

		//  
		for(i=0;i<count;i++)
		{
			errorCode=UF_DISP_set_highlight(object[i],0);
			PRTERR;

			/*int	type,subtype;
			errorCode=UF_OBJ_ask_type_and_subtype(object[i],&type,&subtype);PRTERR;
			fprintf(prterr,"\n\ttype= %d\tsubtype= %d\n",type,subtype); */


		}

		component_group=object;
		component_count=count;

	}





	//  
	{
		char*	
			title="RIVET";
		char*
			rivet_type="work";
		UF_ATTR_value_t 
			value;
		int
			i;

		value.type = UF_ATTR_string;
		value.value.string = rivet_type;
        		
		for(i=0;i<component_count;i++)
		{
			errorCode=UF_ATTR_assign (component_group[i],title,value); 
			PRTERR(__LINE__);
		}

	
	}




		



	goto term;
term:
	return errorCode;

}






/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
	//   
	struct	tm*	newtime;
	time_t	aclock,start_time,finish_time;
	double	work_time;
	int		min,sec;

	
	time(&start_time);	// 

	//     D:
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
		goto label_clock;

	uc1601("    ",1);
	return;

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"\n <set_attribute_RIVET_for_rivets>	HAS STARTED		line=%d\n",__LINE__);
	
	fprintf(prterr,"\n    :	%s\n\n",asctime(newtime));

	errorCode=UF_initialize();PRTERR;


	//     
	parent_part=UF_PART_ask_display_part();
	if(parent_part==NULL_TAG)
	{
		uc1601("  ",1);
		fprintf(prterr,"\n	   	line=%d\n",__LINE__);
		goto term;
	}

	*returnCode=do_it();
	*returnCode=0;

	errorCode=UF_terminate();PRTERR;

	
term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n <set_attribute_RIVET_for_rivets>	HAS FINISHED	line=%d\n",__LINE__);
	fprintf(prterr,"\n working time is %u min   %u sec\n",min,sec);
		
	
	fflush(prterr);
	fclose(prterr);
	return;
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}